//
// DHTMLɂUÎ߂̃vg^Cv  ATL ܂
// DHTMLŋLqꂽ UI NX̋@\ĂяoĎs邱Ƃł
//
// Programed by Go Watanabe (go@dsl.gr.jp)
// ςԂǂ߂񈵂ł낵
//
// st@C݂tH_ɑ΂ăANZXvOC𓋍 (vgR:arc)
// arc:start.htm ŏ̉ʂƂċN
//
#include <windows.h>

#include <atlbase.h>
CComModule _Module;
#include <atlwin.h>
#include <atlcom.h>
#include <atlhost.h>
#include <atliface.h>

#pragma warning(disable: 4786)
#pragma warning(disable: 4291)
#include <string>
using namespace std;

typedef std::basic_string<wchar_t> WideString;

/**
 * vgRp̃vOC
 * w肳ꂽx[XpXɂt@CJĕԂ̃vgR
 * ƎA[JCuɂ邱ƂŁAHTML ̃t@C
 * SăA[JCuQƂ邱Ƃł邱ƂɂȂB
 * IClassFactory d˂ĎBɖ͂Ȃ?
 */ 
class CArcProtocol : public IInternetProtocol, public IClassFactory
{
private:

	// Plugin ʐMp
	CComPtr<IInternetProtocolSink>	m_pProtocolSink;
	CComPtr<IInternetBindInfo>		m_pBindInfo;

	// QƃJE^
	ULONG count;

	// t@CT̃x[XpX
	WideString basePath;

	// JĂt@C̃nhƃTCY
	HANDLE hFile;
	DWORD size;

public:

	/**
	 * RXgN^
	 */
	CArcProtocol(const wchar_t *basepath) : basePath(basepath) {
		hFile = INVALID_HANDLE_VALUE;
		count = 0;
		AddRef();
	}

	/**
	 * fXgN^
	 */
	~CArcProtocol() {
		if (hFile != INVALID_HANDLE_VALUE) {
			CloseHandle(hFile);
			hFile = INVALID_HANDLE_VALUE;
		}
	}
	
	//----------------------------------------------------------------------------
	// IUnknown 
	
	HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid,
											 void __RPC_FAR *__RPC_FAR *ppvObject) {
		if (riid == IID_IUnknown ||
			riid == IID_IInternetProtocolRoot ||
			riid == IID_IInternetProtocol) {
			if (ppvObject == NULL)
				return E_POINTER;
			*ppvObject = this;
			AddRef();
			return S_OK;
		} else {
			*ppvObject = 0;
			return E_NOINTERFACE;
		}
	}
	
	ULONG STDMETHODCALLTYPE AddRef() {
		return ++count;
	}
	
	ULONG STDMETHODCALLTYPE Release() {
		if (--count == 0) {
			delete this;
		}
		return count;
	}

	//----------------------------------------------------------------------------
	// IInternetProtocolRoot
	
	HRESULT STDMETHODCALLTYPE Abort( 
		/* [in] */ HRESULT hrReason,
		/* [in] */ DWORD dwOptions)	{
		if (hFile != INVALID_HANDLE_VALUE) {
			CloseHandle(hFile);
			hFile = INVALID_HANDLE_VALUE;
		}
		return S_OK;
	}
	
	HRESULT STDMETHODCALLTYPE Continue( 
		/* [in] */ PROTOCOLDATA __RPC_FAR *pProtocolData) {
		return S_OK;
	}
	
	HRESULT STDMETHODCALLTYPE Suspend(void) {return E_NOTIMPL;}
	HRESULT STDMETHODCALLTYPE Resume(void) {return E_NOTIMPL;}
	
	HRESULT STDMETHODCALLTYPE Terminate( 
		/* [in] */ DWORD dwOptions)	{
		if (hFile != INVALID_HANDLE_VALUE) {
			CloseHandle(hFile);
			hFile = INVALID_HANDLE_VALUE;
		}
		return S_OK;	
	}

	HRESULT STDMETHODCALLTYPE Start(
		/* [in] */ LPCWSTR szUrl, 
		/* [in] */ IInternetProtocolSink __RPC_FAR  *pOIProtSink,
		/* [in] */ IInternetBindInfo __RPC_FAR *pOIBindInfo,
		/* [in] */ DWORD grfPI,
		/* [in] */ DWORD dwReserved) {
		
		// ʐMpɃ|C^ۑ
		m_pProtocolSink = pOIProtSink;
		m_pBindInfo = pOIBindInfo;

		// t@C
		WideString filePath(basePath);

		// vgRw̓ǂݔ΂
		const wchar_t *p = szUrl;
		while (*p && *p != ':') {
			p++;
		}
		if (*p == ':') {
			p++;
		} else {
			p = szUrl;
		}

		// vgRwȍ~̓pXƂ݂Ȃăx[Xɒǉ
		while (*p) {
			filePath += *p++;
		}
		
		// t@CI[văTCY擾
		hFile = CreateFileW(filePath.data(),
							GENERIC_READ,
							FILE_SHARE_READ,
							NULL,
							OPEN_EXISTING,
							FILE_ATTRIBUTE_NORMAL,
							NULL);
		if (hFile != INVALID_HANDLE_VALUE) {
			size = GetFileSize(hFile, NULL);
			if (size != INVALID_FILE_SIZE) {
				// f[^Ƃꂽ̂ʒm
				m_pProtocolSink->ReportData(BSCF_DATAFULLYAVAILABLE, size, size);
			} else {
				CloseHandle(hFile);
				hFile = INVALID_HANDLE_VALUE;
			}
		}
		return S_OK;
	}
	
	//----------------------------------------------------------------------------
	// IInternetProtocol
	
	HRESULT STDMETHODCALLTYPE LockRequest(/* [in] */ DWORD dwOptions) {
		return S_OK;
	}

	HRESULT STDMETHODCALLTYPE UnlockRequest(void) {
		return S_OK;
	}

	/**
	 * t@C̓ǂ݂
	 */
	HRESULT STDMETHODCALLTYPE Read( 
		/* [length_is][size_is][out][in] */ void __RPC_FAR *pv,
		/* [in] */ ULONG cb,
		/* [out] */ ULONG __RPC_FAR *pcbRead) {
		if (hFile != INVALID_HANDLE_VALUE && ReadFile(hFile, pv, cb, pcbRead, NULL)) {
			if (*pcbRead == cb) {
				return S_OK;
			} else {
				return S_FALSE;
			}
		}
		return INET_E_DOWNLOAD_FAILURE;
	}

	HRESULT STDMETHODCALLTYPE Seek( 
		/* [in] */ LARGE_INTEGER dlibMove,
		/* [in] */ DWORD dwOrigin,
		/* [out] */ ULARGE_INTEGER __RPC_FAR *plibNewPosition) {
		return E_NOTIMPL;
	}

	//----------------------------------------------------------------------------
	// IClassFactory

	HRESULT STDMETHODCALLTYPE CreateInstance(
		IUnknown *pUnkOuter,
		REFIID riid,
		void **ppvObject) {
		if (riid == IID_IUnknown || riid == IID_IInternetProtocol) {
			*ppvObject = (void*)new CArcProtocol(basePath.data());
			return S_OK;
		} else {
			return E_NOINTERFACE;
		}
	}
	
	HRESULT STDMETHODCALLTYPE LockServer(BOOL fLock) {
		return S_OK;
	}
};

/**
 * DHTML̊Oďo(window.external)ƊeUI󗝂邽߂̃NX
 * CAxWindow::SetExternalUIHandler Őݒ肷邱Ƃz肵ĂB
 * getExternal \bhŁAOĂяop IDispatch ԂĂB
 *
 * window.external.SetBackColor wiFݒ肷郁\bh
 * window.external.EndProgram vOI郁\bh
 *
 * ꂼNX̑Ή郁\bhĂяoĂBpĒgLq邱Ƃ
 * ύXł
 */ 
class CHtmlExt : public IDocHostUIHandlerDispatch {

public:
	//----------------------------------------------------------------------------
	// IUnknown 
	
	HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid,
											 void __RPC_FAR *__RPC_FAR *ppvObject) {
		if (riid == IID_IUnknown || riid == IID_IDispatch) {
			if (ppvObject == NULL)
				return E_POINTER;
			*ppvObject = this;
			AddRef();
			return S_OK;
		} else {
			*ppvObject = 0;
			return E_NOINTERFACE;
		}
	}

	ULONG STDMETHODCALLTYPE AddRef() {
		return 1;
	}

	ULONG STDMETHODCALLTYPE Release() {
		return 1;
	}

	//----------------------------------------------------------------------------
	// IDispatch 

	STDMETHOD(GetTypeInfoCount)(UINT* pctinfo) {
		return E_NOTIMPL;
	}

	STDMETHOD(GetTypeInfo)(UINT itinfo, LCID lcid, ITypeInfo** pptinfo) {
		return E_NOTIMPL;
	}

	enum {
		NONE = 0,
		SETBGCOLOR = 1,
		ENDPROGRAM = 2,
	};

	/**
	 * \bhID̑ΉƂ郁\bh
	 * regszNames Ƀ\bh̔z񂪂̂ŁA
	 * rgdispid ɑΉ dispid ԂĂ
	 */
	STDMETHOD(GetIDsOfNames)(REFIID riid, LPOLESTR* rgszNames, UINT cNames,
							 LCID lcid, DISPID* rgdispid) {
		UINT i;
		for (i=0; i<cNames; i++) {
			// `ׂ}b`O(
			if (wcscmp(rgszNames[i], OLESTR("SetBgColor")) == 0) {
				rgdispid[i] = SETBGCOLOR;
			} else if (wcscmp(rgszNames[i], OLESTR("EndProgram")) == 0) {
				rgdispid[i] = ENDPROGRAM;
			} else {
				rgdispid[i] = NONE;
			}
		}
		return S_OK;
	}

	/**
	 * \bhs
	 * dispidMember Ń\bhw肳B pdispparams  VARIANT ̔z
	 * ̌`ł킽̂łg
	 */
	STDMETHOD(Invoke)(DISPID dispidMember, REFIID riid,
					  LCID lcid, WORD wFlags, DISPPARAMS* pdispparams, VARIANT* pvarResult,
					  EXCEPINFO* pexcepinfo, UINT* puArgErr) {
		switch (dispidMember) {
		case SETBGCOLOR:
			return SetBgColor(pdispparams, pvarResult, pexcepinfo, puArgErr);
		case ENDPROGRAM:
			return EndProgram(pdispparams, pvarResult, pexcepinfo, puArgErr);
		}
		return E_NOTIMPL;
	}

	/**
	 * wiFw
	 */
	virtual HRESULT SetBgColor(DISPPARAMS* pdispparams, VARIANT* pvarResult,
							EXCEPINFO* pexcepinfo, UINT* puArgErr) {
		// {͂ň`FbNKv
		//  2 (1:Body Element, 2: F)
		CComQIPtr<IHTMLBodyElement> spBody(pdispparams->rgvarg[1].pdispVal);
		if (spBody != NULL) {
			spBody->put_bgColor(pdispparams->rgvarg[0]);
		}
		return S_OK;
	}

	/**
	 * vOI (Ƃ肠gȂ)
	 */
	virtual HRESULT EndProgram(DISPPARAMS* pdispparams, VARIANT* pvarResult,
							   EXCEPINFO* pexcepinfo, UINT* puArgErr) {
		return S_OK;
	}
	
	//----------------------------------------------------------------------------
	// IDocHostUIHandlerDispatch ̎

	/**
	 * ReLXgj[
	 * ȂƂŃj[Ă
	 */
	HRESULT STDMETHODCALLTYPE ShowContextMenu( 
		/* [in] */ DWORD dwID,
		/* [in] */ DWORD x,
		/* [in] */ DWORD y,
		/* [in] */ IUnknown __RPC_FAR *pcmdtReserved,
		/* [in] */ IDispatch __RPC_FAR *pdispReserved,
		/* [retval][out] */ HRESULT __RPC_FAR *dwRetVal) {
		*dwRetVal = S_OK;      //This is what the WebBrowser control is looking for.
		//You can show your own context menu here.
		return S_OK;        
	}

	HRESULT STDMETHODCALLTYPE GetHostInfo( 
		/* [out][in] */ DWORD __RPC_FAR *pdwFlags,
		/* [out][in] */ DWORD __RPC_FAR *pdwDoubleClick) {
		return E_NOTIMPL;
	}

	HRESULT STDMETHODCALLTYPE ShowUI( 
		/* [in] */ DWORD dwID,
		/* [in] */ IUnknown __RPC_FAR *pActiveObject,
		/* [in] */ IUnknown __RPC_FAR *pCommandTarget,
		/* [in] */ IUnknown __RPC_FAR *pFrame,
		/* [in] */ IUnknown __RPC_FAR *pDoc,
		/* [retval][out] */ HRESULT __RPC_FAR *dwRetVal) {
		return E_NOTIMPL;
	}
        
	HRESULT STDMETHODCALLTYPE HideUI( void) {
		return E_NOTIMPL;
	}
        
	HRESULT STDMETHODCALLTYPE UpdateUI( void) {
		return E_NOTIMPL;
	}
        
	HRESULT STDMETHODCALLTYPE EnableModeless(
		/* [in] */ VARIANT_BOOL fEnable) {
		return E_NOTIMPL;
	}

	HRESULT STDMETHODCALLTYPE OnDocWindowActivate( 
		/* [in] */ VARIANT_BOOL fActivate) {
		return E_NOTIMPL;
	}
        
	HRESULT STDMETHODCALLTYPE OnFrameWindowActivate(
		/* [in] */ VARIANT_BOOL fActivate) {
		return E_NOTIMPL;
	}
        
	HRESULT STDMETHODCALLTYPE ResizeBorder( 
		/* [in] */ long left,
		/* [in] */ long top,
		/* [in] */ long right,
		/* [in] */ long bottom,
		/* [in] */ IUnknown __RPC_FAR *pUIWindow,
		/* [in] */ VARIANT_BOOL fFrameWindow) {
		return E_NOTIMPL;
	}
	
	HRESULT STDMETHODCALLTYPE TranslateAccelerator( 
		/* [in] */ DWORD hWnd,
		/* [in] */ DWORD nMessage,
		/* [in] */ DWORD wParam,
		/* [in] */ DWORD lParam,
		/* [in] */ BSTR bstrGuidCmdGroup,
		/* [in] */ DWORD nCmdID,
		/* [retval][out] */ HRESULT __RPC_FAR *dwRetVal) {
		return E_NOTIMPL;
	}
	
	HRESULT STDMETHODCALLTYPE GetOptionKeyPath( 
		/* [out] */ BSTR __RPC_FAR *pbstrKey,
		/* [in] */ DWORD dw) {
		return E_NOTIMPL;
	}
        
	HRESULT STDMETHODCALLTYPE GetDropTarget( 
		/* [in] */ IUnknown __RPC_FAR *pDropTarget,
		/* [out] */ IUnknown __RPC_FAR *__RPC_FAR *ppDropTarget) {
		return E_NOTIMPL;
	}
        
	HRESULT STDMETHODCALLTYPE GetExternal( 
		/* [out] */ IDispatch __RPC_FAR *__RPC_FAR *ppDispatch) {
		*ppDispatch = this;
		return E_NOTIMPL;
	}
        
	HRESULT STDMETHODCALLTYPE TranslateUrl( 
		/* [in] */ DWORD dwTranslate,
		/* [in] */ BSTR bstrURLIn,
		/* [out] */ BSTR __RPC_FAR *pbstrURLOut) {
		return E_NOTIMPL;
	}
        
	HRESULT STDMETHODCALLTYPE FilterDataObject( 
		/* [in] */ IUnknown __RPC_FAR *pDO,
		/* [out] */ IUnknown __RPC_FAR *__RPC_FAR *ppDORet) {
		return E_NOTIMPL;
	}
};

/**
 * HTMLR|[lgEChENX̎
 * CAxWindow gāAʂς IER|[lg쐬Ă
 */
class CMyWindow :
	public CWindowImpl<CMyWindow, CWindow>,
	public CHtmlExt
{	
public:
	// uEŨRg[
	CComPtr<IWebBrowser2> browser;
	
private:

	// HTMLRg[
	CAxWindow htmlCtrlWnd;

	BEGIN_MSG_MAP(CMyWindow)
		MESSAGE_HANDLER(WM_CREATE,   OnCreate)
		MESSAGE_HANDLER(WM_DESTROY,  OnDestroy)
	END_MSG_MAP()

	/**
	 * 
	 */
	LRESULT OnCreate(UINT, WPARAM, LPARAM, BOOL&) {

		// Rg[쐬
		// ̃TCYƓTCYɍ쐬
		RECT rect;
		GetClientRect(&rect);
		htmlCtrlWnd.Create(m_hWnd, rect, NULL, WS_CHILD | WS_VISIBLE | WS_BORDER, 0, 1);

		// Rg[쐬
		HRESULT hr = htmlCtrlWnd.CreateControl(OLESTR("Shell.Explorer.2"));
		if (SUCCEEDED(hr)) {
			// g external pɓo^B
			// SetExternalDispatch {̖̂ړĨ\bh
			// IDocHostUIHandlerDispatch gꍇ͂ GetExternal D悳
			// ̂ŖӖɂȂBSetExternalUIHandler ł̈ꊇwsB
			//hr = htmlCtrlWnd.SetExternalDispatch(static_cast<CHtmlExt*>(this));
			hr = htmlCtrlWnd.SetExternalUIHandler(static_cast<CHtmlExt*>(this));
			if (SUCCEEDED(hr)) {
				// C^[tF[X擾
				hr = htmlCtrlWnd.QueryControl(&browser);
			}
		}
		return SUCCEEDED(hr) ? 0 : -1;
	}

	/**
	 * 폜
	 */
	LRESULT OnDestroy(UINT, WPARAM, LPARAM, BOOL&){
		if (browser) {
			// C^[tF[Xꍇ͉Ă
			browser.Release();
			browser.Detach();
		}
		// AvP[VI
		PostQuitMessage(0);
		return 0;
    }

	/**
	 * external Ăяop̃\bhI[oCh
	 */
	HRESULT EndProgram(DISPPARAMS* pdispparams, VARIANT* pvarResult,
					   EXCEPINFO* pexcepinfo, UINT* puArgErr) {
		if (MessageBox(_T("I܂"), _T("ImF"), MB_OKCANCEL) == IDOK) {
			DestroyWindow();
		} else {
			UpdateWindow(); // ʃtbVȂƂ݂c炵c
		}
		return S_OK;
	}
};

/**
 * CvO
 */
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	// ATL֘A
	_Module.Init(NULL, hInstance);
	AtlAxWinInit();
	
	// vO̎spX̎擾 (vgR̃x[Xɂ)
	wchar_t basePath[MAX_PATH];
	wchar_t tmp[MAX_PATH];
	wchar_t *p;
	GetModuleFileNameW(NULL, tmp, MAX_PATH);
	GetFullPathNameW(tmp, MAX_PATH, basePath, &p);
	*p = '\0';

	// vgRpt@Ng̓o^
	// arc: ƂOœo^
	CArcProtocol factory(basePath);
	GUID dummy;
	IInternetSession *session;
	CoInternetGetSession(0, &session, 0); // vZX IInternetSession 擾āc
	session->RegisterNameSpace(&factory, (REFCLSID)dummy, L"arc", 0, NULL, 0); // ɃGg

	// 쐬
	CMyWindow wnd;
	wnd.Create(NULL, CWindow::rcDefault, NULL, WS_OVERLAPPEDWINDOW|WS_VISIBLE);
	
	// uEUɃt@CJ
	CComVariant vUrl("arc:start.htm");
	CComVariant vempty;
	wnd.browser->Navigate2(&vUrl, &vempty, &vempty, &vempty, &vempty);

	// bZ[W[v
	MSG msg;
	while (GetMessage(&msg, NULL, 0, 0)){
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	int ret = msg.wParam;

	_Module.Term();
	return ret;
}
